Index: GTP/trunk/App/Demos/Illum/IBRBillboardCloudTrees/OGRE/IBRTreesOGRE/obj/Release/BuildLog.htm
===================================================================
--- GTP/trunk/App/Demos/Illum/IBRBillboardCloudTrees/OGRE/IBRTreesOGRE/obj/Release/BuildLog.htm	(revision 1493)
+++ GTP/trunk/App/Demos/Illum/IBRBillboardCloudTrees/OGRE/IBRTreesOGRE/obj/Release/BuildLog.htm	(revision 1546)
@@ -12,31 +12,31 @@
 </pre></table><table width=100% bgcolor=#DFDFE5><tr><td><font face=arial size=+2>
 Líneas de comandos
-</font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Creando archivo temporal "l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\RSP0000DC.rsp" con contenido
+</font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Creando archivo temporal "l:\isma\IBRTreesOGRE\obj\Release\RSP000001.rsp" con contenido
 [
-/O2 /I "..\include" /I "L:\isma\OgreSDK121\include" /D "NDEBUG" /D "_WINDOWS" /D "WIN32" /D "_MBCS" /FD /EHsc /MD /Fp".\..\obj\Release/Demo_SkyPlane.pch" /Fo".\..\obj\Release/" /Fd".\..\obj\Release/" /W3 /c  /D "TIXML_USE_STL"
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\src\IndirectTexturing.cpp
+/O2 /I "..\include" /I "l:\isma\OgreSDK123\include" /D "NDEBUG" /D "_WINDOWS" /D "WIN32" /D "_MBCS" /FD /EHsc /MD /Fp".\..\obj\Release/Demo_SkyPlane.pch" /Fo".\..\obj\Release/" /Fd".\..\obj\Release/" /W3 /c  /D "TIXML_USE_STL"
+\isma\IBRTreesOGRE\src\IndirectTexturing.cpp
 ]
-Creando línea de comandos "cl.exe @l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\RSP0000DC.rsp /nologo"
-Creando archivo temporal "l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\RSP0000DD.rsp" con contenido
+Creando línea de comandos "cl.exe @l:\isma\IBRTreesOGRE\obj\Release\RSP000001.rsp /nologo"
+Creando archivo temporal "l:\isma\IBRTreesOGRE\obj\Release\RSP000002.rsp" con contenido
 [
-/OUT:"..\bin\Release/Demo_IndirectTexturing.exe" /INCREMENTAL:NO /NOLOGO /LIBPATH:"L:\isma\OgreSDK121\lib" /PDB:"..\bin\Release\Demo_IndirectTexturing.pdb" /SUBSYSTEM:WINDOWS /MACHINE:X86 OgreMain.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\IndirectTexturing.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\tinyxmlparser.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\OgreOSMScene.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\tinystr.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\tinyxml.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\tinyxmlerror.obj
+/OUT:"..\bin\Release/Demo_IndirectTexturing.exe" /INCREMENTAL:NO /NOLOGO /LIBPATH:"l:\isma\OgreSDK123\lib" /PDB:"..\bin\Release\Demo_IndirectTexturing.pdb" /SUBSYSTEM:WINDOWS /MACHINE:X86 OgreMain.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib
+\isma\IBRTreesOGRE\obj\Release\IndirectTexturing.obj
+\isma\IBRTreesOGRE\obj\Release\OgreOSMScene.obj
+\isma\IBRTreesOGRE\obj\Release\tinystr.obj
+\isma\IBRTreesOGRE\obj\Release\tinyxml.obj
+\isma\IBRTreesOGRE\obj\Release\tinyxmlerror.obj
+\isma\IBRTreesOGRE\obj\Release\tinyxmlparser.obj
 ]
-Creando línea de comandos "link.exe @l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\RSP0000DD.rsp"
+Creando línea de comandos "link.exe @l:\isma\IBRTreesOGRE\obj\Release\RSP000002.rsp"
 </pre></table><table width=100% bgcolor=#DFDFE5><tr><td><font face=arial size=+2>
 Ventana de resultados
 </font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Compilando...
 IndirectTexturing.cpp
-..\include\IndirectTexturing.h(430) : warning C4018: '<' : no coinciden signed/unsigned
+..\include\IndirectTexturing.h(447) : warning C4018: '<' : no coinciden signed/unsigned
 Vinculando...
 </pre></table><table width=100% bgcolor=#DFDFE5><tr><td><font face=arial size=+2>
 Resultados
 </font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>
-El registro de generación se guardó en el "file://l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Release\BuildLog.htm"
+El registro de generación se guardó en el "file://l:\isma\IBRTreesOGRE\obj\Release\BuildLog.htm"
 Demo_IndirectTexturing - 0 error(es), 1 advertencia(s)</pre></table><table   width=100% height=20 bgcolor=#CFCFE5><tr><td><font face=arial size=+2>
 </font></table></body></html>
Index: GTP/trunk/App/Demos/Illum/IBRBillboardCloudTrees/OGRE/IBRTreesOGRE/obj/Debug/BuildLog.htm
===================================================================
--- GTP/trunk/App/Demos/Illum/IBRBillboardCloudTrees/OGRE/IBRTreesOGRE/obj/Debug/BuildLog.htm	(revision 1493)
+++ GTP/trunk/App/Demos/Illum/IBRBillboardCloudTrees/OGRE/IBRTreesOGRE/obj/Debug/BuildLog.htm	(revision 1546)
@@ -12,26 +12,26 @@
 </pre></table><table width=100% bgcolor=#DFDFE5><tr><td><font face=arial size=+2>
 Líneas de comandos
-</font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Creando archivo temporal "l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\RSP0000DE.rsp" con contenido
+</font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Creando archivo temporal "l:\isma\IBRTreesOGRE\obj\Debug\RSP000003.rsp" con contenido
 [
-/Od /I "..\include" /I "L:\isma\OgreSDK121\include" /D "_WINDOWS" /D "_DEBUG" /D "WIN32" /D "_MBCS" /FD /EHsc /RTC1 /MDd /Fp".\..\obj\Debug/Demo_SkyPlane.pch" /Fo".\..\obj\Debug/" /Fd".\..\obj\Debug/" /W3 /c /ZI  /Zm500 /D "TIXML_USE_STL"
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\src\IndirectTexturing.cpp
+/Od /I "..\include" /I "l:\isma\OgreSDK123\include" /D "_WINDOWS" /D "_DEBUG" /D "WIN32" /D "_MBCS" /FD /EHsc /RTC1 /MDd /Fp".\..\obj\Debug/Demo_SkyPlane.pch" /Fo".\..\obj\Debug/" /Fd".\..\obj\Debug/" /W3 /c /ZI  /Zm500 /D "TIXML_USE_STL"
+\isma\IBRTreesOGRE\src\IndirectTexturing.cpp
 ]
-Creando línea de comandos "cl.exe @l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\RSP0000DE.rsp /nologo"
-Creando archivo temporal "l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\RSP0000DF.rsp" con contenido
+Creando línea de comandos "cl.exe @l:\isma\IBRTreesOGRE\obj\Debug\RSP000003.rsp /nologo"
+Creando archivo temporal "l:\isma\IBRTreesOGRE\obj\Debug\RSP000004.rsp" con contenido
 [
-/OUT:"..\bin\Debug/Demo_IndirectTexturing.exe" /INCREMENTAL:NO /NOLOGO /LIBPATH:"L:\isma\OgreSDK121\lib" /DEBUG /PDB:"..\bin\Debug\Demo_IndirectTexturing.pdb" /SUBSYSTEM:WINDOWS /MACHINE:X86 OgreMain_d.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\IndirectTexturing.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\tinyxmlparser.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\OgreOSMScene.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\tinystr.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\tinyxml.obj
-\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\tinyxmlerror.obj
+/OUT:"..\bin\Debug/Demo_IndirectTexturing.exe" /INCREMENTAL:NO /NOLOGO /LIBPATH:"l:\isma\OgreSDK123\lib" /DEBUG /PDB:"..\bin\Debug\Demo_IndirectTexturing.pdb" /SUBSYSTEM:WINDOWS /MACHINE:X86 OgreMain_d.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib
+\isma\IBRTreesOGRE\obj\Debug\IndirectTexturing.obj
+\isma\IBRTreesOGRE\obj\Debug\OgreOSMScene.obj
+\isma\IBRTreesOGRE\obj\Debug\tinystr.obj
+\isma\IBRTreesOGRE\obj\Debug\tinyxml.obj
+\isma\IBRTreesOGRE\obj\Debug\tinyxmlerror.obj
+\isma\IBRTreesOGRE\obj\Debug\tinyxmlparser.obj
 ]
-Creando línea de comandos "link.exe @l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\RSP0000DF.rsp"
+Creando línea de comandos "link.exe @l:\isma\IBRTreesOGRE\obj\Debug\RSP000004.rsp"
 </pre></table><table width=100% bgcolor=#DFDFE5><tr><td><font face=arial size=+2>
 Ventana de resultados
 </font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>Compilando...
 IndirectTexturing.cpp
-l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\include\IndirectTexturing.h(430) : warning C4018: '<' : no coinciden signed/unsigned
+l:\isma\IBRTreesOGRE\include\IndirectTexturing.h(447) : warning C4018: '<' : no coinciden signed/unsigned
 Vinculando...
 LINK : warning LNK4075: se omite '/EDITANDCONTINUE' debido a la especificación '/INCREMENTAL:NO'
@@ -39,5 +39,5 @@
 Resultados
 </font></table><table width=* cellspacing=0 cellpadding=0><tr><td width=0 bgcolor=#EDEDF5>&nbsp;</td><td width=0 bgcolor=#FFFFFF>&nbsp;</td><td width=*><pre>
-El registro de generación se guardó en el "file://l:\isma\IndirectTexturingOGRE14072006\IndirectTexturing\obj\Debug\BuildLog.htm"
+El registro de generación se guardó en el "file://l:\isma\IBRTreesOGRE\obj\Debug\BuildLog.htm"
 Demo_IndirectTexturing - 0 error(es), 2 advertencia(s)</pre></table><table   width=100% height=20 bgcolor=#CFCFE5><tr><td><font face=arial size=+2>
 </font></table></body></html>