Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_aaa.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_aaa.html	(revision 1532)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_aaa.html	(revision 1550)
@@ -23,60 +23,52 @@
                 <UL>
                     <H3>2006</H3>
-                    <LI STYLE="text-align: left;">Dmitry SOKOLOV, Dimitri PLEMENOS, Karim TAMINE, <A HREF="http://www.gametools.org/archives/publications/LIM_tvc2006.pdf"><B>Methods and data structures for virtual world exploration</B></A><B>, </B>The Visual Computer (Volume 22, Number 7, pages 506  516), July 2006</LI>
+                    <LI STYLE="text-align: left;">C. Rebollo, I. Remolar, M. Chover, and J. Gumbau, <A HREF="http://www.gametools.org/archives/publications/UJI_ISCIS2006.pdf"><B>Hardware-Oriented Visualisation of Trees</B></A>, ISCIS 2006, LNCS 4263 proceedings, november 2006</LI>
+                    <LI><A HREF="http://www.cg.tuwien.ac.at/staff/IvanViola.html">Ivan Viola</A>, <A HREF="http://ima.udg.es/~feixas/">Miquel Feixas</A>, <A HREF="http://ima.udg.es/~mateu/">Mateu Sbert</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/EduardGroeller.html">Meister Eduard Groller</A>, <B><A HREF="http://www.gametools.org/archives/publications/VUT_TVCG2006.pdf">Importance-Driven Focus of Attention</A>, </B><I>IEEE Transactions on Visualization and Computer Graphics</I>, 12(5):933-940, October 2006. </LI>
+                    <LI STYLE="text-align: left;">F. Ramos, M. Chover, O. Ripolles and C. Granell, <A HREF="http://www.gametools.org/archives/publications/UJI_DGCI2006.pdf"><B>Continuous Level of Detail on Graphics Hardware</B></A>, Lecture Notes in Computer Science&nbsp;Vol. 4245.Proceedings of the 13th International Conference on Discrete Geometry for Computer Imagery, october 2006. ISBN: 3-540-47651-2.</LI>
+                    <LI>Barnabás Aszódi, László Szirmay-Kalos: <B><A HREF="http://www.iit.bme.hu/~szirmay/softshadow_link.htm">Real-time Soft Shadows with Shadow Accumulation,</A></B> Eurographics Short Papers, september 2006. </LI>
+                    <LI>Vlastimil Havran, <A HREF="http://www.cg.tuwien.ac.at/staff/JiriBittner.html">Jiri Bittner</A>, <B><A HREF="http://www.gametools.org/archives/publications/tut4eg06.pdf">Efficient Sorting and Searching in Rendering Algorithms</A></B>, tutorial 4, Eurographics 2006, september 2006</LI>
+                    <LI>Szirmay-Kalos László, Szécsi László, Mateu Sbert: <B><A HREF="http://www.iit.bme.hu/~szirmay/gpugi_link.htm">GPUGI: Global Illumination Effects on the GPU</A></B>, Eurographics Tutorial, september 2006. </LI>
+                    <LI>Pierre Rousseau and Vincent Jolivet and Djamchid Ghazanfarpour, <A HREF="http://www.msi.unilim.fr/basilic/Publications/2006/RJG06/"><B>Realistic real-time rain rendering</B></A>, Computers &amp; Graphics (volume 30, number 4, pages 507-518, august 2006)</LI>
+                    <LI>F. Ramos, M. Chover, O. Ripolles and C. Granell, <A HREF="http://www.gametools.org/archives/publications/UJI_VIIP2006.pdf"><B>Efficient Implementation of LodStrips</B></A>, Proceedings of the Sixth IASTED International Conference on Visualization, Imaging and Image Processing, ISBN 0-88986-598-1, ISSN 1482-7921, pp. 365-370. August 2006.</LI>
+                    <LI><A HREF="http://www.cg.tuwien.ac.at/staff/PeterWonka.html">Peter Wonka</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/MichaelWimmer.html">Michael Wimmer</A>, Kaichi Zhou, Stefan Maierhofer, <A HREF="http://www.cg.tuwien.ac.at/staff/GerdHesina.html">Gerd Hesina</A>, Alexander Reshetov, <B><A HREF="http://www.gametools.org/archives/publications/VUT_TG2006.pdf">Guided Visibility Sampling</A>, </B><I>ACM Transactions on Graphics,</I> 25(3):-, July 2006. </LI>
+                    <LI>Dmitry SOKOLOV, Dimitri PLEMENOS, Karim TAMINE, <A HREF="http://www.gametools.org/archives/publications/LIM_tvc2006.pdf"><B>Methods and data structures for virtual world exploration</B></A><B>, </B>The Visual Computer (Volume 22, Number 7, pages 506  516), July 2006</LI>
                     <LI STYLE="text-align: left;"><B></B>Dimitri PLEMENOS, Dmitry SOKOLOV, <A HREF="http://www.gametools.org/archives/publications/LIM_graphicon2006.pdf"><B>Intelligent scene display and exploration</B></A><B>, </B>International Conference GraphiCon'2006, Novosibirsk (Russia), June 30- July 5, 2006, pp.&nbsp;?. STAR Report.</LI>
-                    <LI STYLE="text-align: left;">Benoît JAUBERT, Karim TAMINE, Dimitri PLEMENOS, <B><A HREF="http://www.gametools.org/archives/publications/LIM_3ia2006.pdf">Techniques for off-line exploration using a virtual camera</A></B>, 9<SUP>th</SUP> International Conference 3IA2006, May 23-24, 2006, pp. 31-44. Dimitri PLEMENOS (Editor)</LI>
-                    <LI STYLE="text-align: left;">Dmitry SOKOLOV, Dimitri PLEMENOS, Karim TAMINE, <A HREF="http://www.gametools.org/archives/publications/LIM_grapp2006.pdf"><B>Viewpoint quality and global scene exploration strategies</B></A>, International Conference in Computer Graphics and Applications (GRAPP'2006), Setubal (Portugal), February 2006, pp.184-191.</LI>
-                    <UL>
-                        <UL>
-                        </UL>
-                    </UL>
-                    <LI STYLE="text-align: left;">Pierre Rousseau and Vincent Jolivet and Djamchid Ghazanfarpour, <A HREF="http://www.msi.unilim.fr/basilic/Publications/2006/RJG06/"><B>Realistic real-time rain rendering</B></A>, Computers &amp; Graphics (volume 30, number 4, pages 507-518)</LI>
-                    <UL>
-                        <UL>
-                        </UL>
-                    </UL>
-                    <LI><A HREF="http://www.cg.tuwien.ac.at/staff/IvanViola.html">Ivan Viola</A>, <A HREF="http://ima.udg.es/~feixas/">Miquel Feixas</A>, <A HREF="http://ima.udg.es/~mateu/">Mateu Sbert</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/EduardGroeller.html">Meister Eduard Groller</A>, <B><A HREF="http://www.gametools.org/archives/publications/VUT_TVCG2006.pdf">Importance-Driven Focus of Attention</A>, </B><I>IEEE Transactions on Visualization and Computer Graphics</I>, 12(5):933-940, October 2006. </LI>
+                    <LI STYLE="text-align: left;"><A HREF="http://www.cg.tuwien.ac.at/staff/OliverMattausch.html">Oliver Mattausch</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/JiriBittner.html">Jiri Bittner</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/MichaelWimmer.html">Michael Wimmer</A>, <B><A HREF="http://www.gametools.org/archives/publications/VUT_EGSR2006.pdf">Adaptive Visibility-Driven View Cell Construction</A>, </B>In <I>Rendering Techniques 2006 (Proceedings of the Eurographics Symposium on Rendering 2006)</I>, pages -. June 2006.</LI>
+                    <LI>Szécsi László, Szirmay-Kalos László, Mateu Sbert: <B><A HREF="http://www.iit.bme.hu/~szirmay/precomp_link.htm">Light Animation with Precomputed Light Paths on the GPU</A></B>, Graphics Interface, June 2006. </LI>
+                    <LI>Tamás Umenhoffer, László Szirmay-Kalos, Gábor Szijártó: <B><A HREF="http://www.iit.bme.hu/~szirmay/firesmoke_link.htm">Spherical Billboards and their Application to Rendering Explosions</A></B>, Graphics Interface June 2006. </LI>
+                    <LI>Benoît JAUBERT, Karim TAMINE, Dimitri PLEMENOS, <B><A HREF="http://www.gametools.org/archives/publications/LIM_3ia2006.pdf">Techniques for off-line exploration using a virtual camera</A></B>, 9<SUP>th</SUP> International Conference 3IA2006, May 23-24, 2006, pp. 31-44. Dimitri PLEMENOS (Editor)</LI>
+                    <LI STYLE="text-align: left;">P. Castelló, M. Sbert, M. Chover, M. Feixas, <A HREF="http://www.gametools.org/archives/publications/UJI_ICCS2006_2.pdf"><B>Techniques for Computing Viewpoint Entropy of a 3D Scene</B></A>, ICCS 2006, University of Reading, UK, May, 2006.</LI>
+                    <LI>O. Belmonte, S. Aguado, S. Sancho, <A HREF="http://www.gametools.org/archives/publications/UJI_ICCS2006.pdf"><B>Triangle Strip Multiresolution Modelling using sorted edges</B></A>, ICCS 2006, University of Reading, UK, May, 2006.</LI>
+                    <LI>Celso Campos, Ricardo Quiros, Joaquin Huerta, Emilio Camahort, Roberto Vivo, Javier Lluch: <A HREF="http://www.gametools.org/archives/publications/UPV_UJI_ccampos_cggm2006.pdf"><B>A Multiresolution Model for Non-Photorealistic Rendering of Trees</B></A>, Fifth International Workshop on Computer Graphics and Geometric Modeling - CGGM May 2006.</LI>
+                    <LI>Szirmay-Kalos László, Lazányi István: <B><A HREF="http://www.iit.bme.hu/~szirmay/ibld7_link.htm">Indirect Diffuse and Glossy Illumination on the GPU</A></B>, SCCG, April 2006. </LI>
+                    <LI>Dmitry SOKOLOV, Dimitri PLEMENOS, Karim TAMINE, <A HREF="http://www.gametools.org/archives/publications/LIM_grapp2006.pdf"><B>Viewpoint quality and global scene exploration strategies</B></A>, International Conference in Computer Graphics and Applications (GRAPP'2006), Setubal (Portugal), February 2006, pp.184-191.</LI>
+                    <LI STYLE="text-align: left;">C. Rebollo, I. Remolar, M. Chover, O. Ripollés: <A HREF="http://www.gametools.org/archives/publications/UJI_WSCG2006.pdf"><B>An efficient continuous level of detail model for foliage</B></A>, Journal of WSCG, University of West Bohemia, ISBN/ISSN ISBN 80-86943-05-4, Plzen (Czech Republic), February 2006 </LI>
+                    <LI>J. Gumbau, M. Chover: <A HREF="http://www.gametools.org/archives/publications/UJI_WSCG2006_2.pdf"><B>Conceptual design of a programmable geometry generator</B></A>, Journal of WSCG, University of West Bohemia, ISBN/ISSN ISBN 80-86943-05-4, Plzen (Czech Republic), February 2006 </LI>
+                    <LI>Alex Méndez, Mateu Sbert, Jordi Catà, Nico Sunyer, Sergi Funtane: <A HREF="http://www.shaderx4.com/" TARGET="_blank"><B>Real-time Obscurances with Color Bleeding,</B></A> ShaderX4: Advanced Rendering Techniques, Edited by Wolfgang Engel, Charles River Media, 2006. </LI>
                     <LI><A HREF="http://www.cg.tuwien.ac.at/staff/MarkusGiegl.html">Markus Giegl</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/MichaelWimmer.html">Michael Wimmer</A>, <B><A HREF="http://www.gametools.org/archives/publications/VUT_CGF2006.pdf">Unpopping: Solving the Image-Space Blend Problem for Smooth Discrete LOD Transition</A>, </B><I>accepted for Computer Graphics Forum</I>, ():-, 2006.</LI>
-                    <LI><A HREF="http://www.cg.tuwien.ac.at/staff/PeterWonka.html">Peter Wonka</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/MichaelWimmer.html">Michael Wimmer</A>, Kaichi Zhou, Stefan Maierhofer, <A HREF="http://www.cg.tuwien.ac.at/staff/GerdHesina.html">Gerd Hesina</A>, Alexander Reshetov, <B><A HREF="http://www.gametools.org/archives/publications/VUT_TG2006.pdf">Guided Visibility Sampling</A>, </B><I>ACM Transactions on Graphics,</I> 25(3):-, July 2006. </LI>
-                    <LI><A HREF="http://www.cg.tuwien.ac.at/staff/OliverMattausch.html">Oliver Mattausch</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/JiriBittner.html">Jiri Bittner</A>, <A HREF="http://www.cg.tuwien.ac.at/staff/MichaelWimmer.html">Michael Wimmer</A>, <B><A HREF="http://www.gametools.org/archives/publications/VUT_EGSR2006.pdf">Adaptive Visibility-Driven View Cell Construction</A>, </B>In <I>Rendering Techniques 2006 (Proceedings of the Eurographics Symposium on Rendering 2006)</I>, pages -. June 2006.</LI>
-                    <LI>Vlastimil Havran, <A HREF="http://www.cg.tuwien.ac.at/staff/JiriBittner.html">Jiri Bittner</A>, <B><A HREF="http://www.gametools.org/archives/publications/tut4eg06.pdf">Efficient Sorting and Searching in Rendering Algorithms</A></B></LI>
-                    <LI>C. Rebollo, I. Remolar, M. Chover, and J. Gumbau, <A HREF="http://www.gametools.org/archives/publications/UJI_ISCIS2006.pdf"><B>Hardware-Oriented Visualisation of Trees</B></A>, ISCIS 2006, LNCS 4263 proceedings.</LI>
-                    <LI>F. Ramos, M. Chover, O. Ripolles and C. Granell, <A HREF="http://www.gametools.org/archives/publications/UJI_DGCI2006.pdf"><B>Continuous Level of Detail on Graphics Hardware</B></A>, Lecture Notes in Computer Science&nbsp;Vol. 4245.Proceedings of the 13th International Conference on Discrete Geometry for Computer Imagery, 2006. ISBN: 3-540-47651-2.</LI>
-                    <LI>F. Ramos, M. Chover, O. Ripolles and C. Granell, <A HREF="http://www.gametools.org/archives/publications/UJI_VIIP2006.pdf"><B>Efficient Implementation of LodStrips</B></A>, Proceedings of the Sixth IASTED International Conference on Visualization, Imaging and Image Processing, ISBN 0-88986-598-1, ISSN 1482-7921, pp. 365-370. 2006.</LI>
-                    <LI>P. Castelló, M. Sbert, M. Chover, M. Feixas, <A HREF="http://www.gametools.org/archives/publications/UJI_ICCS2006_2.pdf"><B>Techniques for Computing Viewpoint Entropy of a 3D Scene</B></A>, ICCS 2006, University of Reading, UK, May, 2006.</LI>
-                    <LI>O. Belmonte, S. Aguado, S. Sancho, <A HREF="http://www.gametools.org/archives/publications/UJI_ICCS2006.pdf"><B>Triangle Strip Multiresolution Modelling using sorted edges</B></A>, ICCS 2006, University of Reading, UK, May, 2006.</LI>
-                    <LI>Celso Campos, Ricardo Quiros, Joaquin Huerta, Emilio Camahort, Roberto Vivo, Javier Lluch: <A HREF="http://www.gametools.org/archives/publications/UPV_UJI_ccampos_cggm2006.pdf"><B>A Multiresolution Model for Non-Photorealistic Rendering of Trees</B></A>, Fifth International Workshop on Computer Graphics and Geometric Modeling - CGGM 2006.</LI>
-                    <LI>C. Rebollo, I. Remolar, M. Chover, O. Ripollés: <A HREF="http://www.gametools.org/archives/publications/UJI_WSCG2006.pdf"><B>An efficient continuous level of detail model for foliage</B></A>, Journal of WSCG, University of West Bohemia, ISBN/ISSN ISBN 80-86943-05-4, Plzen (Czech Republic), February 2006 </LI>
-                    <LI>J. Gumbau, M. Chover: <A HREF="http://www.gametools.org/archives/publications/UJI_WSCG2006_2.pdf"><B>Conceptual design of a programmable geometry generator</B></A>, Journal of WSCG, University of West Bohemia, ISBN/ISSN ISBN 80-86943-05-4, Plzen (Czech Republic), February 2006 </LI>
-                    <LI>Szirmay-Kalos László, Szécsi László, Mateu Sbert: <B><A HREF="http://www.iit.bme.hu/~szirmay/gpugi_link.htm">GPUGI: Global Illumination Effects on the GPU</A></B>, Eurographics Tutorial, 2006. </LI>
-                    <LI>Szécsi László, Szirmay-Kalos László, Mateu Sbert: <B><A HREF="http://www.iit.bme.hu/~szirmay/precomp_link.htm">Light Animation with Precomputed Light Paths on the GPU</A></B>, Graphics Interface 2006. </LI>
-                    <LI>Szirmay-Kalos László, Lazányi István: <B><A HREF="http://www.iit.bme.hu/~szirmay/ibld7_link.htm">Indirect Diffuse and Glossy Illumination on the GPU</A></B>, SCCG, 2006. </LI>
-                    <LI>Barsi Attila, Szirmay-Kalos László, Szécsi László: <B><A HREF="http://www.iit.bme.hu/~szirmay/ibrshadow_link.htm">Image-based Illumination on the GPU,</A></B> Machine Graphics and Vision, 2006. </LI>
-                    <LI>Barnabás Aszódi, László Szirmay-Kalos: <B><A HREF="http://www.iit.bme.hu/~szirmay/softshadow_link.htm">Real-time Soft Shadows with Shadow Accumulation,</A></B> Eurographics Short Papers, 2006. </LI>
-                    <LI>Tamás Umenhoffer, László Szirmay-Kalos, Gábor Szijártó: <B><A HREF="http://www.iit.bme.hu/~szirmay/firesmoke_link.htm">Spherical Billboards and their Application to Rendering Explosions</A></B>, Graphics Interface 2006. </LI>
-                    <LI>Alex Méndez, Mateu Sbert, Jordi Catà, Nico Sunyer, Sergi Funtane: <A HREF="http://www.shaderx4.com/" TARGET="_blank"><B>Real-time Obscurances with Color Bleeding,</B></A> ShaderX4: Advanced Rendering Techniques, Edited by Wolfgang Engel, Charles River Media, 2006. </LI>
+                    <LI STYLE="text-align: left;">Barsi Attila, Szirmay-Kalos László, Szécsi László: <B><A HREF="http://www.iit.bme.hu/~szirmay/ibrshadow_link.htm">Image-based Illumination on the GPU,</A></B> Machine Graphics and Vision, 2006. </LI>
                     <H3>2005</H3>
                     <LI STYLE="text-align: left;">Dmitry SOKOLOV, Dimitri PLEMENOS, <A HREF="http://www.gametools.org/archives/publications/LIM_vast2005.pdf"><B>Viewpoint quality and scene understanding</B></A>, The 6th International&nbsp;Eurographics Symposium on Virtual Reality, Archaeology and Cultural Heritage (VAST'2005), Pisa (Italy), November&nbsp;8-11, 2005, pp. 67-73.</LI>
-                    <LI>Michael Wimmer, Jiri Bittner: <A HREF="http://developer.nvidia.com/object/gpu_gems_2_home.html" TARGET="_blank"><B>Hardware Occlusion Queries Made Useful,</B></A> GPU Gems 2: Programming Techniques for High-Performance Graphics and General-Purpose Computation, pages 91-108. </LI>
+                    <LI STYLE="text-align: left;">Szirmay-Kalos László, Aszódi Barnabás, Lazányi István, Premecz Mátyás: <B><A HREF="http://www.iit.bme.hu/~szirmay/ibl_link.htm">Approximate Ray-Tracing on the GPU with Distance Impostors,</A></B> Eurographics, september 2005. </LI>
+                    <LI>Umenhoffer Tamás, Szirmay-Kalos László: <B><A HREF="http://www.iit.bme.hu/~szirmay/felhos_link.htm">Real-time Rendering of Cloudy Natural Phenomena with Hierarchical Depth Impostors,</A></B> Eurographics Short Papers, September 2005. </LI>
+                    <LI>Ismael Garcia, Mateu Sbert, László Szirmay-Kalos: <B><A HREF="http://www.iit.bme.hu/~szirmay/tree_link.htm">Leaf Cluster Impostors for Tree Rendering with Parallax</A></B>, <I>Eurographics September 2005, Short papers</I></LI>
                     <LI>O. Ripolles, M. Chover, F. Ramos: <A HREF="http://www.gametools.org/archives/publications/UJI_VIIP2005.pdf"><B>Quality strips for models with level of detail</B></A>, Proc. of Visualization, Imaging and Image Processing (VIIP 2005), ISBN/ISSN 0-88986-528-0, Benidorm, pp. 268-273, September 2005 </LI>
                     <LI>O. Ripolles, M. Chover:<A HREF="http://www.gametools.org/archives/publications/UJI_CEIG2005.pdf"><B> Búsqueda de tiras para modelos multirresolución estáticos</B></A>, XV Congreso Español de Informática Gráfica, ISBN/ISSN 84-9732-431-5, Granada, pp. 117-123, September 2005 </LI>
                     <LI>C. González, J. Gumbau, M. Chover: <A HREF="http://www.gametools.org/archives/publications/UJI_CEIG2005_2.pdf"><B>Generación por hardware de mapas de normales</B></A>, XV Congreso Español de Informática Gráfica, ISBN/ISSN 84-9732-431-5, Granada, September 2005 </LI>
                     <LI>P. Castelló, M. Chover: <A HREF="http://www.gametools.org/archives/publications/UJI_CEIG2005_3.pdf"><B>Técnicas para Calcular la Entropía Dependiente de la Vista de una Escena 3D</B></A>, XV Congreso Español de Informática Gráfica, ISBN/ISSN 84-9732-431-5, Granada, pp. 277-280, September 2005 </LI>
-                    <LI>M. Sbert, D. Plemenos, M. Feixas, F. González: <A HREF="http://www.eg.org/EG/DL/WS/COMPAESTH/COMPAESTH05/185-192.pdf"><B>Viewpoint Quality: Measures and Applications</B></A>, Eurographics Workshop on Computacional Aesthetics in Graphics, Visualization and Imaging, May 2005, Girona (Spain)</LI>
+                    <LI>Mateu Sbert, Jordi Palau: <A HREF="http://www.gametools.org/archives/publications/GameTools_MateuSbert_ITRA.pdf"><B>GameTools: Advanced Tools for Developing Highly Realistic Computer Games</B></A> IVth ITRA World Conference, Alicante, July 2005.</LI>
+                    <LI>Dimitri Plemenos, Jerome Grasset, Benoit Jaubert, Karim Tamine: <A HREF="http://www.graphicon.ru/proceedings2005/papers/Plemenos.pdf" TARGET="_blank"><B>Intelligent visibility-based 3D scene processing techniques for computer games,</B></A> Computer Graphics and Applications (GraphiCon'2005), Novosibirsk Akademgorodok, Russia, june 2005. </LI>
                     <LI>J. Rigau, M. Feixas, M. Sbert: <B>Shape Complexity Based on Mutual Information</B>, Proceedings of IEEE International Conference on Shape Modeling and Applications. June 2005, MIT, Cambridge (USA)</LI>
                     <LI>J. Rovira, P. Wonka, F. Castro, M. Sbert: <A HREF="http://www.eg.org/EG/DL/WS/SPBG/SPBG05/109-118.pdf"><B>Point Sampling with Uniformly Distributed Lines</B></A>, Symposium on Point-Based Graphics (PBG05), June 2005, Stony Brook (USA)</LI>
-                    <LI>Jiri Bittner, Peter Wonka, Michael Wimmer: <A HREF="http://www.cgg.cvut.cz/%7Ebittner/publications/egsr05_final_electronic.pdf" TARGET="_blank"><B>Fast Exact From-Region Visibility in Urban Scenes,</B></A> Eurographics Symposium on Rendering 2005. </LI>
-                    <LI>Vlastimil Havran, Jiri Bittner, Robert Herzog, Hans-Peter Seidel: <A HREF="http://www.mpi-sb.mpg.de/%7Ehavran/DOWNLOAD/egsr2005rm.pdf" TARGET="_blank"><B>Ray Maps for Global Illumination,</B></A> Eurographics Symposium on Rendering 2005. </LI>
-                    <LI>Dimitri Plemenos, Jerome Grasset, Benoit Jaubert, Karim Tamine: <A HREF="http://www.graphicon.ru/proceedings2005/papers/Plemenos.pdf" TARGET="_blank"><B>Intelligent visibility-based 3D scene processing techniques for computer games,</B></A> Computer Graphics and Applications (GraphiCon'2005), Novosibirsk Akademgorodok, Russia, 2005. </LI>
-                    <LI>Mateu Sbert, Jordi Palau: <A HREF="http://www.gametools.org/archives/publications/GameTools_MateuSbert_ITRA.pdf" TARGET="_blank"><B>GameTools: Advanced Tools for Developing Highly Realistic Computer Games</A></B> IVth ITRA World Conference, Alicante, 2005.</LI>
-                    <LI>Szirmay-Kalos László, Aszódi Barnabás, Lazányi István, Premecz Mátyás: <B><A HREF="http://www.iit.bme.hu/~szirmay/ibl_link.htm">Approximate Ray-Tracing on the GPU with Distance Impostors,</A></B> Eurographics, 2005. </LI>
+                    <LI>Jiri Bittner, Peter Wonka, Michael Wimmer: <A HREF="http://www.cgg.cvut.cz/%7Ebittner/publications/egsr05_final_electronic.pdf" TARGET="_blank"><B>Fast Exact From-Region Visibility in Urban Scenes,</B></A> Eurographics Symposium on Rendering, june 2005. </LI>
+                    <LI>Vlastimil Havran, Jiri Bittner, Robert Herzog, Hans-Peter Seidel: <A HREF="http://www.mpi-sb.mpg.de/%7Ehavran/DOWNLOAD/egsr2005rm.pdf" TARGET="_blank"><B>Ray Maps for Global Illumination,</B></A> Eurographics Symposium on Rendering, june 2005. </LI>
                     <LI>Szirmay-Kalos László, Mateu Sbert, Umenhoffer Tamás: <B><A HREF="http://www.iit.bme.hu/~szirmay/volreuse_link.htm">Real-Time Multiple Scattering in Participating Media with Illumination Networks,</A></B> Eurographics Symposium on Rendering, 2005. </LI>
-                    <LI>Umenhoffer Tamás, Szirmay-Kalos László: <B><A HREF="http://www.iit.bme.hu/~szirmay/felhos_link.htm">Real-time Rendering of Cloudy Natural Phenomena with Hierarchical Depth Impostors,</A></B> Eurographics Short Papers, 2005. </LI>
-                    <LI>Ismael Garcia, Mateu Sbert, László Szirmay-Kalos: <B><A HREF="http://www.iit.bme.hu/~szirmay/tree_link.htm">Leaf Cluster Impostors for Tree Rendering with Parallax</A></B>, <I>Eurographics 2005, Short papers</I></LI>
-                    <LI>Barsi Attila, Szirmay-Kalos László, Szijártó Gábor: <B><A HREF="http://www.iit.bme.hu/~szirmay/gpurad_link.htm">Stochastic Glossy Global Illumination on the GPU,</A></B> SCCG, 2005. </LI>
-                    <LI>Szirmay-Kalos László, Antal György, Mateu Sbert: <B><A HREF="http://www.iit.bme.hu/~szirmay/gowin_link.htm">Go with the Winners Strategy in Path Tracing,</A></B> Journal of WSCG, 2005. </LI>
-                    <LI>Lazányi István, Szirmay-Kalos László: <B><A HREF="http://www.iit.bme.hu/~szirmay/fresnel_link.htm">Fresnel Term Approximations for Metals,</A></B> WSCG 2005. Short papers. </LI>
+                    <LI>M. Sbert, D. Plemenos, M. Feixas, F. González: <A HREF="http://www.eg.org/EG/DL/WS/COMPAESTH/COMPAESTH05/185-192.pdf"><B>Viewpoint Quality: Measures and Applications</B></A>, Eurographics Workshop on Computacional Aesthetics in Graphics, Visualization and Imaging, May 2005, Girona (Spain)</LI>
+                    <LI>Pascual Castelló, José Francisco Ramos, Miguel Chover: <A HREF="http://www.gametools.org/archives/publications/UJI_ICSS2005.pdf"><B>A Comparative Study of Acceleration Techniques for Geometric Visualization</B></A><B>.</B> Fourth International Workshop on Computer Graphics and Geometric Modeling, CGGM May 2005.</LI>
+                    <LI>Barsi Attila, Szirmay-Kalos László, Szijártó Gábor: <B><A HREF="http://www.iit.bme.hu/~szirmay/gpurad_link.htm">Stochastic Glossy Global Illumination on the GPU,</A></B> SCCG, April 2005. </LI>
                     <LI>Stefan Jeschke, Michael Wimmer, Heidrun Schumann, Werner Purgathofer: <A HREF="http://www.gametools.org/archives/publications/VUT_ACM_Siggraph2005_jeschke-05-AIP-Paper.pdf"><B>Automatic Impostor Placement for Guaranteed Frame Rates and Low Memory Requirements</B></A><B>,</B> In Proceedings of ACM SIGGRAPH 2005 Symposium on Interactive 3D Graphics and Games. April 2005.</LI>
-                    <LI>Pascual Castelló, José Francisco Ramos, Miguel Chover: <A HREF="http://www.gametools.org/archives/publications/UJI_ICSS2005.pdf"><B>A Comparative Study of Acceleration Techniques for Geometric Visualization</B></A><B>.</B> Fourth International Workshop on Computer Graphics and Geometric Modeling, CGGM 2005.
+                    <LI>Michael Wimmer, Jiri Bittner: <A HREF="http://developer.nvidia.com/object/gpu_gems_2_home.html" TARGET="_blank"><B>Hardware Occlusion Queries Made Useful,</B></A> GPU Gems 2: Programming Techniques for High-Performance Graphics and General-Purpose Computation, pages 91-108, march 2006.</LI>
+                    <LI>Szirmay-Kalos László, Antal György, Mateu Sbert: <B><A HREF="http://www.iit.bme.hu/~szirmay/gowin_link.htm">Go with the Winners Strategy in Path Tracing,</A></B> Journal of WSCG, February 2005. </LI>
+                    <LI>Lazányi István, Szirmay-Kalos László: <B><A HREF="http://www.iit.bme.hu/~szirmay/fresnel_link.htm">Fresnel Term Approximations for Metals,</A></B> WSCG, February 2005. Short papers. 
                 </UL>
             </TD>